import { ReactNode } from "react";
import { SsProps } from "./useSs";
import { Sizes } from "./units/tshirts";
declare const ssProps: readonly ["px", "pl", "pr", "mx", "ml", "mr"];
declare const weights: {
    ultra: number;
    black: number;
    bold: number;
    semiBold: number;
    medium: number;
    regular: number;
    light: number;
    thin: number;
    ultrathin: number;
};
declare type Weight = keyof typeof weights;
interface Props extends Pick<SsProps, typeof ssProps[number]> {
    children: ReactNode;
    color?: string;
    size?: Sizes;
    weight?: Weight;
}
declare const _default: ({ weight, ...props }: Props) => import("@emotion/react/jsx-runtime").JSX.Element;
export default _default;
